<?php
namespace Opencart\Admin\Model\Extension\Vipodha4blogger\Module;
class VipodhaBlogger extends \Opencart\System\Engine\Model {

	public function createBlogs() {
		$create_vipodha_blogger = "CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "vipodha_blogger` (`vipodha_blogger_id` int(11) NOT NULL auto_increment, `module_id` int(11) NOT NULL, `status` int(1) NOT NULL default '0', `image` varchar(255) default NULL, `banner_image` varchar(255) default NULL, `date_added` datetime NOT NULL default '0000-00-00 00:00:00', `date_modified` datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (`vipodha_blogger_id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;";
		$this->db->query($create_vipodha_blogger);

		$create_vipodha_blogger_description = "CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "vipodha_blogger_description` (`vipodha_blogger_id` int(11) NOT NULL default '0', `language_id` int(11) NOT NULL default '0', `title` varchar(64) NOT NULL default '', `description` text NOT NULL, PRIMARY KEY (`vipodha_blogger_id`,`language_id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;";
		$this->db->query($create_vipodha_blogger_description);

		$create_vipodha_blogger_comment = "CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "vipodha_blogger_comment` (`vipodha_blogger_comment_id` int(11) NOT NULL auto_increment, `vipodha_blogger_id` int(11) NOT NULL, `approved` int(1) NOT NULL default '0', `author` varchar(64) NOT NULL default '', `email` varchar(96) NOT NULL, `date_added` datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (`vipodha_blogger_comment_id`, `vipodha_blogger_id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;";
		$this->db->query($create_vipodha_blogger_comment);

		$create_vipodha_blogger_comment_description = "CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "vipodha_blogger_comment_description` (`vipodha_blogger_comment_id` int(11) NOT NULL default '0', `language_id` int(11) NOT NULL default '0', `comment` text NOT NULL, PRIMARY KEY (`vipodha_blogger_comment_id`,`language_id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;";
		$this->db->query($create_vipodha_blogger_comment_description);
	}

	public function dropBlogs() {
		$drop_vipodha_blogger = "DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_blogger`;";
		$this->db->query($drop_vipodha_blogger);

		$drop_vipodha_blogger_description = "DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_blogger_description`;";
		$this->db->query($drop_vipodha_blogger_description);

		$drop_vipodha_blogger_comment = "DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_blogger_comment`;";
		$this->db->query($drop_vipodha_blogger_comment);

		$drop_vipodha_blogger_comment_description = "DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_blogger_comment_description`;";
		$this->db->query($drop_vipodha_blogger_comment_description);
	}

	public function addModule($code, $data) {
		$this->db->query("INSERT INTO `" . DB_PREFIX . "module` SET `name` = '" . $this->db->escape($data['name']) . "', `code` = '" . $this->db->escape($code) . "', `setting` = '" . $this->db->escape(json_encode($data)) . "'");

		$module_id = $this->db->getLastId();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "module WHERE module_id = '" . (int)$module_id . "'");

		$settings = json_decode($query->row['setting'], true);

		$settings['module_id'] = $module_id;

		$this->db->query("UPDATE " . DB_PREFIX . "module SET setting = '" . $this->db->escape(json_encode($settings)) . "' WHERE module_id = '" . (int)$module_id . "'");

		return $module_id;
	}

	public function addBlog($data) {		
		$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_blogger SET module_id = '" . (int)$data['module_id'] . "', status = '" . (int)$data['status'] . "', date_added = now(), date_modified = now()");

		$vipodha_blogger_id = $this->db->getLastId();

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger SET image = '" . $this->db->escape($data['image']) . "' WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");
		}
		if (isset($data['banner_image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger SET banner_image = '" . $this->db->escape($data['banner_image']) . "' WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");
		}

		foreach ($data['vipodha_blogger_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_blogger_description SET vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}
	}

	public function editBlog($vipodha_blogger_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger SET module_id = '" . (int)$data['module_id'] . "', status = '" . (int)$data['status'] . "', date_modified = now() WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger SET image = '" . $this->db->escape($data['image']) . "' WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");
		}

		if (isset($data['banner_image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger SET banner_image = '" . $this->db->escape($data['banner_image']) . "' WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_blogger_description WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		foreach ($data['vipodha_blogger_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_blogger_description SET vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}
	}

	public function deleteBlog($vipodha_blogger_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_blogger WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_blogger_description WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");
	}	

	public function getBlog($vipodha_blogger_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "vipodha_blogger WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		return $query->row;
	}

	public function getBlogTitle($vipodha_blogger_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger_description WHERE language_id = '" . (int)$this->config->get('config_language_id') . "' AND vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		if ($query->row) {
			return $query->row['title'];
		} else {
			return false;
		}
	}

	public function getBlogDescriptions($vipodha_blogger_id) {
		$vipodha_blogger_description_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger_description WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		foreach ($query->rows as $result) {
			$vipodha_blogger_description_data[$result['language_id']] = array(
				'title'       => $result['title'],
				'description' => $result['description']
			);
		}

		return $vipodha_blogger_description_data;
	}

	public function deleteBlogComment($vipodha_blogger_comment_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_blogger_comment WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_blogger_comment_description WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");
	}

	public function approveComment($vipodha_blogger_comment_id) {
		$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger_comment SET approved = '1' WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");
	}

	public function disapproveComment($vipodha_blogger_comment_id) {
		$this->db->query("UPDATE " . DB_PREFIX . "vipodha_blogger_comment SET approved = '0' WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");
	}

	public function getTotalBlogComments($vipodha_blogger_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "vipodha_blogger_comment WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

		if ($query->row) {
			return $query->row['total'];
		} else {
			return false;
		}
	}

	public function getBlogComments($vipodha_blogger_id, $data = array()) {
		if ($data) {
			$sql = "SELECT * FROM " . DB_PREFIX . "vipodha_blogger_comment WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'";

			$sort_data = array(
				'author',
				'date_added'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY date_added";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = $this->db->query($sql);

			return $query->rows;
		} else {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger_comment WHERE vipodha_blogger_id = '" . (int)$vipodha_blogger_id . "'");

			return $query->rows;
		}
	}

	public function getBlogComment($vipodha_blogger_comment_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger_comment WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");

		return $query->row;
	}

	public function getBlogCommentDescriptions($vipodha_blogger_comment_id) {
		$vipodha_blogger_comment_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger_comment_description WHERE vipodha_blogger_comment_id = '" . (int)$vipodha_blogger_comment_id . "'");

		foreach ($query->rows as $result) {
			$vipodha_blogger_comment_data[$result['language_id']] = array(
				'comment' => $result['comment']
			);
		}

		return $vipodha_blogger_comment_data;
	}

	public function getBlogsByModule($module_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger b LEFT JOIN " . DB_PREFIX . "vipodha_blogger_description bd ON (b.vipodha_blogger_id = bd.vipodha_blogger_id) WHERE bd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND b.module_id = '" . (int)$module_id . "' ORDER BY b.date_added");

		return $query->rows;
	}

	public function getBlogs($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM " . DB_PREFIX . "vipodha_blogger b LEFT JOIN " . DB_PREFIX . "vipodha_blogger_description bd ON (b.vipodha_blogger_id = bd.vipodha_blogger_id) WHERE bd.language_id = '" . (int)$this->config->get('config_language_id') . "'";

			$sort_data = array(
				'bd.title',
				'b.module_id',
				'b.date_added'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY b.module_id, b.date_added";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = $this->db->query($sql);

			return $query->rows;
		} else {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_blogger b LEFT JOIN " . DB_PREFIX . "vipodha_blogger_description bd ON (b.vipodha_blogger_id = bd.vipodha_blogger_id) WHERE bd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY b.date_added ASC");

			return $query->rows;
		}
	}

	public function getTotalBlogs() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "vipodha_blogger");

		return $query->row['total'];
	}

	public function getModule($module_id) {
		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "module` WHERE `module_id` = '" . (int)$module_id . "'");

		return $query->row;
	}
}