<?php
namespace Opencart\Admin\Model\Extension\Vipodha4featurecategory\Module;
class VipodhaFeatureCategory extends \Opencart\System\Engine\Model {
	
	public function install(): void {
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "feature_category` (
			`feature_category_id` INT(11) NOT NULL AUTO_INCREMENT,			
			`category_id` int NOT NULL,			
			`banner` varchar(255) COLLATE utf8mb4_general_ci DEFAULT NULL,
			PRIMARY KEY (`feature_category_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=DYNAMIC");
		$this->db->query( $sql );
	}

	public function uninstall(): void {
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "feature_category`");
	}

	public function getVipodhaFeaturecategory($category_id = 0,$languages_ids = array()) {
		if(count($languages_ids) > 0){
			$languages_id = implode(", ",$languages_ids);
			$sql = "SELECT fc.feature_category_id, fc.category_id, fc.banner, cd.name, cd.language_id FROM " . DB_PREFIX . "feature_category fc RIGHT JOIN " . DB_PREFIX . "category_description cd ON (fc.category_id = cd.category_id) WHERE cd.category_id= '" . (int)$category_id . "' AND  cd.language_id IN($languages_id)";
		}else{			
			$sql = "SELECT fc.feature_category_id, fc.category_id, fc.banner, cd.name, DISTINCT cd.language_id FROM " . DB_PREFIX . "feature_category fc RIGHT JOIN " . DB_PREFIX . "category_description cd ON (fc.category_id = cd.category_id) WHERE cd.category_id= '" . (int)$category_id . "'";
		}
		$query = $this->db->query($sql);
		return $query->rows;
	}

	public function SaveVipodhaFeaturecategory($category_id, $data) {
		if($category_id){			
			$select_sql = "SELECT COUNT(*) AS total FROM " . DB_PREFIX . "feature_category fc WHERE fc.category_id= '" . (int)$category_id . "'";
			$select_result = $this->db->query($select_sql);
			if((int)$select_result->row['total'] > 0){
				$sql = "UPDATE " . DB_PREFIX . "feature_category fc SET fc.banner = '".$this->db->escape($data['banner'])."' WHERE fc.category_id = '" . (int)$category_id."'";
			}else{
				$sql = "INSERT INTO " . DB_PREFIX . "feature_category SET category_id = '" . (int)$category_id . "', banner = '".$this->db->escape($data['banner'])."'";
			}
			$this->db->query($sql);
		}
	}
}
?>

