<?php
namespace Opencart\Catalog\Controller\Extension\Vipodha4featurecategory\Module;
class VipodhaFeatureCategory extends \Opencart\System\Engine\Controller {

	public function index($setting) {
		$this->load->language('extension/vipodha4featurecategory/module/vipodha_feature_category');
		$data['heading_title'] = $this->language->get('heading_title');
		$this->load->model('catalog/category');
		$this->load->model('catalog/product');
		$this->load->model('tool/image');
		$this->load->model('extension/vipodha4featurecategory/module/vipodha_feature_category');

		$this->document->addScript('extension/vipodha4featurecategory/catalog/view/javascript/owl.carousel.min.js');
		$this->document->addStyle('extension/vipodha4featurecategory/catalog/view/css/owl.carousel.min.css');	
		$this->document->addStyle('extension/vipodha4featurecategory/catalog/view/css/style.css');
		
		$data['categories'] = array();
	
		if (!isset($setting['limit'])) {
			$setting['limit'] = 4;
		}		

		$data['view_desc_status'] = $setting['view_desc_status'];

		if (!empty($setting['category'])) {
			$categories = array_slice($setting['category'], 0, (int)$setting['limit']);		

			foreach ($categories as $category_id) {
				$category_info = $this->model_catalog_category->getCategory($category_id);			
				$children_data = array();

				if ($category_info) {

					$children = $this->model_catalog_category->getCategories($category_info['category_id']);
					foreach($children as $child) {
						$filter_data = array('filter_category_id' => $child['category_id'], 'filter_sub_category' => true);

						$children_data[] = array(
							'category_id' => $child['category_id'],
							'name' => $child['name'] . ($this->config->get('config_product_count') ? ' (' . $this->model_catalog_product->getTotalProducts($filter_data) . ')' : ''),
							'href' => $this->url->link('product/category', 'path=' . $category_info['category_id'] . '_' . $child['category_id'])
						);
					}

					$category_banner = $this->model_extension_vipodha4featurecategory_module_vipodha_feature_category->getVipodhaFeaturecategorybanner($category_id);

					if($category_banner == null){
						$category_info['banner'] = $category_info['image'];
					}else{
						$category_info['banner'] = $category_banner;
					}

					if(isset($category_info['banner'])) {
						$image = $this->model_tool_image->resize(html_entity_decode($category_info['banner'], ENT_QUOTES, 'UTF-8'), $setting['width'], $setting['height']);
					} else {
						$image = $this->model_tool_image->resize('placeholder.png', $setting['width'], $setting['height']);
					}

					$data['categories'][] = array(
						'category_id'  => $category_info['category_id'],
						'thumb'       => $image,
						'name'        => $category_info['name'],
						'children'    => $children_data,						
						'description' => oc_substr(trim(strip_tags(html_entity_decode($category_info['description'], ENT_QUOTES, 'UTF-8'))), 0, $setting['char_limit']) . '...',
						'href'        => $this->url->link('product/category', 'path=' . $category_info['category_id'])
					);
				}
			}
		}

		if (file_exists(DIR_EXTENSION . 'vipodha4featurecategory/catalog/view/template/module/vipodha_feature_category.twig')) {
			return $this->load->view('extension/vipodha4featurecategory/module/vipodha_feature_category', $data);
		} else {
			return;
		}
	}
}
