<?php
namespace Opencart\Catalog\Controller\Extension\Vipodha4newsletter\Module;
class VipodhaNewsletter extends \Opencart\System\Engine\Controller {
	private $error = [];
	
	public function index($setting): string {
		$this->load->language('extension/vipodha4newsletter/module/vipodha_newsletter');
		$this->load->model('extension/vipodha4newsletter/module/vipodha_newsletter');
		$this->document->addScript('extension/vipodha4newsletter/catalog/view/javascript/jquery.cookie.js');
		$this->document->addStyle('extension/vipodha4newsletter/catalog/view/css/style.css');

		$data['user_subscribe'] = $this->url->link('extension/vipodha4newsletter/module/vipodha_newsletter|subscribe');
		$data['user_subscribe_popup'] = $this->url->link('extension/vipodha4newsletter/module/vipodha_newsletter|subscribepopup');

		// echo "<pre>";print_r($setting);echo "</pre>";
		$this->load->model('tool/image');
		if(isset($setting['newsletter_image']) && $setting['newsletter_image'] != '') {
			$newsletter_image = $setting['newsletter_image'];
		}else{
			$newsletter_image = 'no_image.png';
		}
		
		$block_width = 1470;
		$block_height = 400;
		$popup_image_width = 310;
		$popup_image_height = 345;
		
		if (file_exists(DIR_EXTENSION . 'vipodha4newsletter/catalog/view/template/module/vipodha_newsletter.twig')) {
		    if(isset($setting['popup']) && $setting['popup']==1) {	
				$data['newsletter_image'] = $this->model_tool_image->resize($newsletter_image, $popup_image_width, $popup_image_height);
				return $this->load->view('extension/vipodha4newsletter/module/vipodha_newsletter_popup',$data);
			}else {
				$data['newsletter_image'] = $this->model_tool_image->resize($newsletter_image, $block_width, $block_height);
				return $this->load->view('extension/vipodha4newsletter/module/vipodha_newsletter',$data);
			}
		} else {
			return '';
		}
	}

	public function subscribe() : void {
		$json = [];	
		$this->load->language('extension/vipodha4newsletter/module/vipodha_newsletter');
		$this->load->model('extension/vipodha4newsletter/module/vipodha_newsletter');

		if (isset($this->request->post['vipodha_newsletter_usr_email']) and filter_var($this->request->post['vipodha_newsletter_usr_email'],FILTER_VALIDATE_EMAIL)) {
			if (!$this->model_extension_vipodha4newsletter_module_vipodha_newsletter->checkalreadyemail($this->request->post)) {
				$this->model_extension_vipodha4newsletter_module_vipodha_newsletter->subscribe($this->request->post);
				$json['success'] = $this->language->get('success_subscribe');
				$json['form_reset'] = "yes";
			}else{	
			$json['error'] = $this->language->get('already_subscribe');
			}
		}else{
			$json['error'] = $this->language->get('error_message');
		}
		
		$this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));	
	}

	public function subscribepopup() : void {
	  	$this->load->language('extension/vipodha4newsletter/module/vipodha_newsletter');
		$this->load->model('extension/vipodha4newsletter/module/vipodha_newsletter');
	 
		if (isset($this->request->post['vipodha_newsletter_usr_popup_email']) and filter_var($this->request->post['vipodha_newsletter_usr_popup_email'],FILTER_VALIDATE_EMAIL)) {
			$this->request->post['vipodha_newsletter_usr_email'] = $this->request->post['vipodha_newsletter_usr_popup_email']; 
			if (!$this->model_extension_vipodha4newsletter_module_vipodha_newsletter->checkalreadyemail($this->request->post)) {
				$this->model_extension_vipodha4newsletter_module_vipodha_newsletter->subscribe($this->request->post);
				$json['success'] = $this->language->get('success_subscribe');	
				$json['form_reset'] = "yes";			 
			} else {
				$json['error'] = $this->language->get('already_subscribe');
			}
		} else {			
			$json['error'] = $this->language->get('error_message');
		}

		$this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));	  
	}

	protected function loadmodule() {
		$this->load->language('extension/vipodha4newsletter/module/vipodha_newsletter');
		$data = [];
		if (file_exists(DIR_EXTENSION . 'vipodha4newsletter/catalog/view/template/module/vipodha_newsletter.twig')) {
			return $this->load->view('extension/vipodha4newsletter/module/vipodha_newsletter', $data);
		}else{
			return;
		}
	}
}
