<?php
namespace Opencart\Admin\Model\Extension\Vipodha4testimonial\Module;
class VipodhaTestimonial extends \Opencart\System\Engine\Model {
	public function install(){
		
		$sql = [];

		$sql[] = "CREATE TABLE IF NOT EXISTS `".DB_PREFIX."vipodha_testimonial` (
			`vipodha_testimonial_id` INT(11) NOT NULL AUTO_INCREMENT,
			`status` TINYINT(1) NOT NULL DEFAULT 0,
			`sort_order` INT(11) NOT NULL DEFAULT 0,
			PRIMARY KEY (`vipodha_testimonial_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci AUTO_INCREMENT=1;";

		$sql[] = "CREATE TABLE IF NOT EXISTS `".DB_PREFIX."vipodha_testimonial_description`(
			`vipodha_testimonial_id` INT(11) NOT NULL,
			`language_id` INT(11) NOT NULL,
			`image` VARCHAR(255) NOT NULL ,
			`customer_name` VARCHAR(255) NOT NULL,
			`content` TEXT NOT NULL,
			PRIMARY KEY (`vipodha_testimonial_id`,`language_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;";		

		foreach($sql as $q ){
			$query = $this->db->query( $q );
		}
		return true;
		
	}

	public function uninstall() {
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_testimonial`");
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "vipodha_testimonial_description`");
	}

	public function addVipodhaTestimonial($data) {

		$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_testimonial SET status = '" . (int)$this->request->post['status'] . "', sort_order = '" . (int)$this->request->post['sort_order'] . "'");
		$vipodha_testimonial_id = $this->db->getLastId();
		foreach ($data['vipodha_testimonial_description'] as $language_id => $value) {			
			
			$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_testimonial_description SET vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "',language_id = '" . (int)$language_id . "', customer_name = '" . $this->db->escape($value['customer_name']). "',image = '".$this->db->escape($data['image'])."', content = '" . $this->db->escape($value['content']) . "'");
		}

		$this->cache->delete('vipodha_testimonial');
		return $vipodha_testimonial_id;
	}
	
	public function editVipodhaTestimonial($vipodha_testimonial_id, $data) {

		$this->db->query("UPDATE " . DB_PREFIX . "vipodha_testimonial SET status = '" . (int)$this->request->post['status'] . "', sort_order = '" . (int)$data['sort_order'] . "' WHERE vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_testimonial_description WHERE vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "'");
		
		foreach ($data['vipodha_testimonial_description'] as $language_id => $value) {

			$this->db->query("INSERT INTO " . DB_PREFIX . "vipodha_testimonial_description SET vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "',language_id = '" . (int)$language_id . "', customer_name = '" . $this->db->escape($value['customer_name']) . "',image = '".$this->db->escape($data['image'])."', content = '" .  $this->db->escape($value['content']) . "'");
		}		
	}

	public function deleteVipodhaTestimonial($vipodha_testimonial_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_testimonial WHERE vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "vipodha_testimonial_description WHERE vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "'");		
	}

	public function getVipodhaTestimonial($vipodha_testimonial_id) {		
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "vipodha_testimonial t LEFT JOIN " . DB_PREFIX . "vipodha_testimonial_description td ON (t.vipodha_testimonial_id = td.vipodha_testimonial_id) WHERE t.vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "' ");		
		
		return $query->row;
	}

	public function getVipodhaTestimonials($data = array()) {
		if ($data) {			
			$sql = "SELECT * FROM " . DB_PREFIX . "vipodha_testimonial_description td LEFT JOIN " . DB_PREFIX . "vipodha_testimonial t ON (t.vipodha_testimonial_id = td.vipodha_testimonial_id) WHERE td.language_id = '" . (int)$this->config->get('config_language_id') . "'";
			
			$sort_data = array(
				'td.customer_name',
				't.sort_order'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY td.customer_name";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}
				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}
				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}
			$query = $this->db->query($sql);
			return $query->rows;
		} else {
			$vipodha_testimonial_data = $this->cache->get('vipodha_testimonial.' . $this->config->get('config_language_id'));
			if (!$vipodha_testimonial_data) {
				$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_testimonial t LEFT JOIN " . DB_PREFIX . "vipodha_testimonial_description td ON (t.vipodha_testimonial_id = td.vipodha_testimonial_id) WHERE td.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY td.customer_name ASC");
				$vipodha_testimonial_data = $query->rows;
				$this->cache->set('vipodha_testimonial.' . $this->config->get('config_language_id'), $vipodha_testimonial_data);
			}
			return $vipodha_testimonial_data;
		}
	}

	public function getVipodhaTestimonialDescriptions($vipodha_testimonial_id) {
		$vipodha_testimonial_description_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "vipodha_testimonial_description WHERE vipodha_testimonial_id = '" . (int)$vipodha_testimonial_id . "'");
		
		foreach ($query->rows as $result) {
			$vipodha_testimonial_description_data[$result['language_id']]= array(
				'customer_name'       => $result['customer_name'],
				'content' => $result['content']
			);
		}

		return $vipodha_testimonial_description_data;
	}

	public function getTotalVipodhaTestimonials() {		
		// $sql = "SELECT COUNT(*) AS total FROM `". DB_PREFIX . "vipodha_testimonial`";
		$sql = "SELECT COUNT(*) AS total FROM `". DB_PREFIX . "vipodha_testimonial` WHERE `status` = 1";
		$query = $this->db->query($sql);
		return (int)$query->row['total'];
	}
}
?>